
           #include <P16F688.INC>
            LIST        p=16F688    ; 
            __CONFIG    H'30D4'      ;  
                                    ; 
            
Sec         equ         0020h  ;
Sec0        equ         0021h   ; 
Sec1        equ         0022h   ;
scetbit     equ         0023h   ;
perem       equ         0024h    ;
skor        equ         0025h
skortmp     equ         0026h    ;
inter       equ         0027h    ;
reg1        equ         0028h    ;
reg2        equ         0029h      ;
reg3        equ         002Ah     ; 
flag2       equ         002Bh       ;
dlin        equ         002Ch
kolxy       equ         002Dh     ;
kolxytmp    equ         002Eh
dlina       equ         002Fh
shetigra    equ         0030h
tmp         equ         0031h
var1        equ         0032h
var2        equ         0033h
perem1      equ         0034h
smehen      equ         0035h
shetx       equ         0036h
regtmp      equ         0037h
FSRtmp1     equ         0038h
ochko       equ         0039h
var         equ         003Ah
sotni       equ         003Bh
desiat      equ         003Ch
edin        equ         003Dh


figur       equ         003Eh
povorot     equ         003Fh
shetperez   equ         006Bh
chislo      equ         006Ch
flag3       equ         006Dh
slpshet     equ         006Eh
sizeHH      equ         0044h
sheterr     equ         0045h
Sec2        equ         0046h
Sec3        equ         0047h
Sec4        equ         0048h

spec        equ         0074h
PCLATH_temp equ         0075h
flag1       equ         0076h
W_temp      equ         0077h
STATUS_temp equ         0078h
FSR_temp    equ         0079h
FSRtmp2     equ         007Ah
flag        equ         007Bh
tmpfig1     equ         007Ch
tmpfig2     equ         007Dh
tmpfig3     equ         007Eh
tmpfig4     equ         007Fh


dataxy      equ         0040h
datay       equ         005Bh
datay1      equ         0063h

datayy      equ         0050h
datayy1     equ         0058h


datafig     equ         00A0h
datafig1    equ         0020h


#DEFINE     start  	PORTA,3
#DEFINE     dwn 	PORTA,4
#DEFINE     lft  	PORTA,5
#DEFINE     rht   	PORTC,3
#DEFINE     up   	PORTC,4


#DEFINE     cs  	PORTC,0
#DEFINE     clk   	PORTC,1
#DEFINE     data  	PORTC,2





            org         0000h           ;      0 PC.
            goto        Start 

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;  
;     2-  3-  
;     

            org         0004h          
            
            

            movwf       W_temp          ;  STATUS  W
            swapf       STATUS,W
            movwf       STATUS_temp
            movf        PCLATH,W
            movwf       PCLATH_temp
            bcf         PCLATH,3
           ; bcf         STATUS,IRP

            movf        FSR,W           ;   FSR,  
            movwf       FSR_temp        ;      

            btfss       INTCON,T0IF
            goto        wavprer
           
            bsf         STATUS,IRP
            movf        FSRtmp2,W
            movwf       FSR
            btfsc       INDF,0
            bsf         reg2,5
            btfss       INDF,0
            bcf         reg2,5
            btfsc       INDF,1
            bsf         reg2,6
            btfss       INDF,1
            bcf         reg2,6
            btfsc       INDF,2
            bsf         reg2,4
            btfss       INDF,2
            bcf         reg2,4
            btfsc       INDF,3
            bsf         reg2,7
            btfss       INDF,3
            bcf         reg2,7
            btfsc       INDF,4
            bsf         reg2,1
            btfss       INDF,4
            bcf         reg2,1
            btfsc       INDF,5
            bsf         reg2,3
            btfss       INDF,5
            bcf         reg2,3
            btfsc       INDF,6
            bsf         reg2,0
            btfss       INDF,6
            bcf         reg2,0
            btfsc       INDF,7
            bsf         reg2,2
            btfss       INDF,7
            bcf         reg2,2
            movlw       .8
            addwf       FSR,F
            btfsc       INDF,0
            bsf         reg1,5
            btfss       INDF,0
            bcf         reg1,5
            btfsc       INDF,1
            bsf         reg1,6
            btfss       INDF,1
            bcf         reg1,6
            btfsc       INDF,2
            bsf         reg1,4
            btfss       INDF,2
            bcf         reg1,4
            btfsc       INDF,3
            bsf         reg1,7
            btfss       INDF,3
            bcf         reg1,7
            btfsc       INDF,4
            bsf         reg1,0
            btfss       INDF,4
            bcf         reg1,0
            btfsc       INDF,5
            bsf         reg1,3
            btfss       INDF,5
            bcf         reg1,3
            btfsc       INDF,6
            bsf         reg1,1
            btfss       INDF,6
            bcf         reg1,1
            btfsc       INDF,7
            bsf         reg1,2
            btfss       INDF,7
            bcf         reg1,2
      
            movlw       .8
            subwf       inter,W
            btfss       STATUS,Z
            goto        i2
            movlw       .32
            movwf       reg3
            goto        intviv
i2          movlw       .7
            subwf       inter,W
            btfss       STATUS,Z
            goto        i3
            movlw       .1
            movwf       reg3
            goto        intviv
i3          movlw       .6
            subwf       inter,W
            btfss       STATUS,Z
            goto        i4
            movlw       .2
            movwf       reg3
            goto        intviv
i4          movlw       .5
            subwf       inter,W
            btfss       STATUS,Z
            goto        i5
            movlw       .128
            movwf       reg3
            goto        intviv
i5          movlw       .4
            subwf       inter,W
            btfss       STATUS,Z
            goto        i6
            movlw       .4
            movwf       reg3
            goto        intviv
i6          movlw       .3
            subwf       inter,W
            btfss       STATUS,Z
            goto        i7
            movlw       .64
            movwf       reg3
            goto        intviv
i7          movlw       .2
            subwf       inter,W
            btfss       STATUS,Z
            goto        i8
            movlw       .16
            movwf       reg3
            goto        intviv
i8          movlw       .8          
            movwf       reg3
            
             
intviv       movlw      .8
             movwf      scetbit
ii1          btfsc      reg1,0
             bsf        data
             btfss      reg1,0
             bcf        data
             bsf        clk
             bcf        clk
             rrf        reg1,F
             decfsz     scetbit,F
             goto       ii1
           
             movlw      .8
             movwf      scetbit
ii2          btfsc      reg2,0
             bsf        data
             btfss      reg2,0
             bcf        data
             bsf        clk
             bcf        clk
             rrf        reg2,F
             decfsz     scetbit,F
             goto       ii2

             movlw      .8
             movwf      scetbit
ii3          btfsc      reg3,0
             bsf        data
             btfss      reg3,0
             bcf        data
             bsf        clk
             bcf        clk
             rrf        reg3,F
             decfsz     scetbit,F
             goto       ii3
        
             bsf        cs
             bcf        cs

            movlw       .8
            subwf       FSR,F
            incf        FSR,F
            movf        FSR,W
            movwf       FSRtmp2
            decfsz      inter,F
            goto        exxit
            movlw       .8
            movwf       inter
            movlw       datayy
            movwf       FSRtmp2
            btfss       flag3,0
            goto        exxit
            bcf         flag3,0
            clrf        shetperez
sx1         bcf         STATUS,IRP
            movlw       datay
            movwf       FSR
            movf        shetperez,W
            addwf       FSR,F
            movf        INDF,W
            movwf       chislo  
            bsf         STATUS,IRP
            movlw       datayy
            movwf       FSR
            movf        shetperez,W
            addwf       FSR,F
            movf        chislo,W
            movwf       INDF
            movlw       .15
            subwf       shetperez,W
            btfsc       STATUS,Z
            goto        exxit
            incf        shetperez,F
            goto        sx1   
            
exxit       movlw       .115
            movwf       TMR0
            bcf         INTCON,T0IF
            movf        FSR_temp,W       
            movwf       FSR
           

exxit1      movf        PCLATH_temp,W
            movwf       PCLATH
            swapf       STATUS_temp,W   ;  STATUS  W
            movwf       STATUS
            swapf       W_temp,F
            swapf       W_temp,W
            retfie                      ;   


wavprer     btfss       flag3,2
            goto        slep
            bcf         T1CON,TMR1ON
            bcf         PIR1,TMR1IF
            decfsz      flag2,F
            goto        e1
            movlw       .4
            movwf       flag2
            bsf         flag,0
e1          movf        skor,W
            movwf       skortmp
            movlw       .176
            movwf       TMR1L         
            movlw       .60
            movwf       TMR1H      
e2          movlw       .205
            addwf       TMR1L,F
            btfsc       STATUS,C
            incf        TMR1H,F 
            movlw       .19
            addwf       TMR1H,F
            decfsz      skortmp,F
            goto        e2
            bsf         T1CON,TMR1ON
            goto        exxit1

slep        bcf         PIR1,TMR1IF
            decfsz      flag2,F
            goto        exxit1
            movlw       .4
            movwf       flag2
            incf        slpshet,F  
            goto        exxit1   
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
; 

Start       bsf         STATUS,RP0
            movlw       b'01110001'
            movwf       OSCCON
            bcf         STATUS,RP0

            movlw       b'00000000'
            movwf       PORTC
            movlw       b'00000000'
            movwf       PORTA
            movlw       0x07
            movwf       CMCON0

            bsf         STATUS,RP0 
            clrf        ANSEL       
            movlw       b'11111000'          
            movwf       TRISC
            movlw       b'11111111'          
            movwf       TRISA
            bcf         STATUS,RP0

            movlw       b'00110000'
            movwf       T1CON
            bcf         PIR1,TMR1IF     ;    TMR1
            bcf         flag,0
            movlw       .4
            movwf       flag2

            bsf         STATUS,RP0      
            bsf         PIE1,TMR1IE     ;. .  TMR1 
            bsf         IOCA,3         
            bcf         STATUS,RP0
            bsf         INTCON,T0IE     ;  TMR0
            bsf         INTCON,PEIE      ; .  . 
            bsf         INTCON,GIE     ;. . .


           
           

            movlw        .0
            movwf        TMR0
            movlw        .8
            movwf        inter
            movlw        datayy
            movwf        FSRtmp2
            bcf          INTCON,T0IF
      
            call         clean

           ; goto         tetrbeg  ;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

            bsf          STATUS,RP0
            movlw        b'11010011'
            movwf        OPTION_REG
            bcf          STATUS,RP0

          
            bcf          flag3,2
            bsf          T1CON,TMR1ON
            bcf          flag,5
zastav      call         vivzast
            
q01         movf         slpshet,W
            sublw        .240
            btfsc        STATUS,C
            goto         q0
            bcf          INTCON,GIE
            call         offreg
            clrf         slpshet
            bcf          INTCON,RAIF
            bsf          INTCON,RAIE
            SLEEP
            bcf          INTCON,RAIE
            bsf          INTCON,GIE
mk1         call         pauskn
            btfss        start
            goto         mk1


q0          btfsc        rht
            goto         q1
            btfsc        flag,5
            goto         qq1
            bsf          flag,5
            goto         qq3
qq1         bcf          flag,5
qq3         call         vivzast
qq2         call         pauskn
            btfss        rht
            goto         qq2

q1          btfsc        lft
            goto         q2
            btfsc        flag,5
            goto         qa1
            bsf          flag,5
            goto         qa3
qa1         bcf          flag,5
qa3         call         vivzast
qa2         call         pauskn
            btfss        lft
            goto         qa2

q2          btfsc        up
            goto         q3
            btfsc        flag,5
            goto         qb1
            bsf          flag,5
            goto         qb3
qb1         bcf          flag,5
qb3         call         vivzast
qb2         call         pauskn
            btfss        up
            goto         qb2

q3          btfsc        dwn
            goto         q4
            btfsc        flag,5
            goto         qc1
            bsf          flag,5
            goto         qc3
qc1         bcf          flag,5
qc3         call         vivzast
qc2         call         pauskn
            btfss        dwn
            goto         qc2

q4          btfss        start
            goto         qx1
            bsf          flag,7
            goto         q01
qx1         btfss        flag,7
            goto         q01

qd1         call         pauskn
            btfss        start
            goto         qd1
            btfsc        flag,5
            goto         tetrbeg

            call         clean


           
zmeia       movlw        .1
            movwf        dlin
            movwf        skor
            bsf          flag,1
            bcf          flag,0
pov4        call         vivdan

          ; goto          begzm  ;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

c01         movf         slpshet,W
            sublw        .240
            btfsc        STATUS,C
            goto         c1
            bcf          INTCON,GIE
            call         offreg
            clrf         slpshet
            bcf          INTCON,RAIF
            bsf          INTCON,RAIE
            SLEEP
            bcf          INTCON,RAIE
            bsf          INTCON,GIE
mk2         call         pauskn
            btfss        start
            goto         mk2

c1          btfsc        up
            goto         c2
            incf         dlin,F
            movf         dlin,W
            sublw        .9
            btfsc        STATUS,C
            goto         cc1
            movlw        .1
            movwf        dlin
cc1         call         vivdan
cc11        call         pauskn
            btfss        up
            goto         cc11
c2          btfsc        dwn
            goto         c3
            incf         skor,F
            movf         skor,W
            sublw        .9
            btfsc        STATUS,C
            goto         cc2
            movlw        .1
            movwf        skor
cc2         call         vivdan
cc12        call         pauskn
            btfss        dwn
            goto         cc12
c3          btfsc        lft
            goto         c4
            btfsc        flag,1
            goto         ccc3
            bsf          flag,1
            goto         cc3
ccc3        bcf          flag,1
cc3         call         vivdan
cc13        call         pauskn
            btfss        lft
            goto         cc13
c4          btfsc        rht
            goto         c5
            btfsc        flag,1
            goto         ccc4
            bsf          flag,1
            goto         cc4
ccc4        bcf          flag,1
cc4         call         vivdan
cc14        call         pauskn
            btfss        rht
            goto         cc14
c5          btfsc        start
            goto         c01
            movlw        .50
            movwf        var
ch4         call         pauskn
            btfsc        start
            goto         begzm
            decfsz       var,F
            goto         ch4
            bcf          flag,7
            goto         zastav

begzm       call         stenka
            movlw        .3
            movwf        shetigra
;fuk         nop
;            goto         fuk

           

pov3        call         nachkor
            movlw        .14
            movwf        dlina
            clrf         flag1
            

pov2        call         koreda

            	
           
pov1        call         vivod

            

pover1      call         oproskn

           


fuk2        movlw        dataxy  ;   .
            movwf        FSR 
            movf         kolxy,W
            addwf        FSR,F
            decf         FSR,F
            decf         FSR,F
            movf         INDF,W
            movwf        perem

rashetkor   movlw        dataxy
            movwf        FSR
            movf         kolxy,W
            addwf        FSR,F
            decf         FSR,F
            decf         FSR,F
dd1         decf         FSR,F
            movf         INDF,W
            incf         FSR,F
            movwf        INDF
            decf         FSR,F
            movlw        dataxy
            subwf        FSR,W
            btfss        STATUS,Z
            goto         dd1

           

            btfss        flag1,0
            goto         d2
dd6         swapf        INDF,F
            movf         INDF,W
            movwf        tmp
            movlw        b'00001111'
            andwf        tmp,F
            incf         tmp,F
            movlw        .8
            subwf        tmp,W
            btfss        STATUS,Z
            goto         dd2
            btfsc        flag,1
            goto         finish
            clrf         tmp
dd2         movlw        .4
            movwf        var1
dd3         rrf          tmp,F
            rrf          INDF,F
            decfsz       var1,F
            goto         dd3
            goto         naezd

d2          btfss        flag1,1
            goto         d3
dd7         swapf        INDF,F
            movf         INDF,W
            movwf        tmp
            movlw        b'00001111'
            andwf        tmp,F
            decf         tmp,F
            movlw        .255
            subwf        tmp,W
            btfss        STATUS,Z
            goto         da1
            btfsc        flag,1
            goto         finish
            movlw        .7
            movwf        tmp
da1         movlw        .4
            movwf        var1
da2         rrf          tmp,F
            rrf          INDF,F
            decfsz       var1,F
            goto         da2
            goto         naezd


d3          btfss        flag1,2
            goto         d4
dd8         movf         INDF,W
            movwf        tmp
            swapf        INDF,F
            movlw        b'00001111'
            andwf        tmp,F
            decf         tmp,F
            movlw        .255
            subwf        tmp,W
            btfss        STATUS,Z
            goto         db1
            btfsc        flag,1
            goto         finish
            movlw        .15
            movwf        tmp
db1         swapf        tmp,F
            movlw        .4
            movwf        var1
db2         rlf          tmp,F
            rlf          INDF,F
            decfsz       var1,F
            goto         db2
            goto         naezd



d4          btfss        flag1,3
            goto         d5
dd9         movf         INDF,W
            movwf        tmp
            swapf        INDF,F
            movlw        b'00001111'
            andwf        tmp,F
            incf         tmp,F
            movlw        .16
            subwf        tmp,W
            btfss        STATUS,Z
            goto         dc1
            btfsc        flag,1
            goto         finish       
            clrf         tmp
dc1         swapf        tmp,F
            movlw        .4
            movwf        var1
dc2         rlf          tmp,F
            rlf          INDF,F
            decfsz       var1,F
            goto         dc2
            goto         naezd

d5          btfsc        flag1,4
            goto         dd6
            btfsc        flag1,5
            goto         dd7
            btfsc        flag1,6
            goto         dd8
            goto         dd9


naezd       movf         kolxy,W
            movwf        kolxytmp
            decf         kolxytmp,F
            decf         kolxytmp,F
            movlw        dataxy
            movwf        FSR          
            movf         INDF,W
            movwf        tmp
ff1         incf         FSR,F
            movf         tmp,W
            subwf        INDF,W
            btfsc        STATUS,Z
            goto         finish
            decfsz       kolxytmp,F
            goto         ff1
            
naezdeda    movlw        dataxy
            movwf        FSR          
            movf         INDF,W
            movwf        tmp
            movf         kolxy,W
            addwf        FSR,F
            decf         FSR,F
            movf         tmp,W
            subwf        INDF,W
            btfss        STATUS,Z
            goto         pov1
            
perashet    movlw        dataxy
            movwf        FSR 
            movf         kolxy,W
            addwf        FSR,F
            decf         FSR,F
            movf         perem,W
            movwf        INDF   

            decfsz       dlina,F
            goto         pov2

            
ff2         btfss       flag,0
            goto        ff2
            
            bcf         flag3,2
            clrf         slpshet
            bcf          flag,0
            incf        dlin,F
            movf        dlin,W
            sublw       .9
            btfsc        STATUS,C
            goto         ff3
            movlw        .1
            movwf        dlin
ff3         goto         pov3



finish      btfss       flag,0
            goto        finish
            bcf         flag3,2
            clrf         slpshet
            bcf          flag,0
            decfsz      shetigra,F
            goto        pov3
            call        stenka
            goto        pov4


;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;




;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

oproskn     movlw       b'11110000'
            andwf       flag1,F

ops1        movf         slpshet,W
            sublw        .240
            btfsc        STATUS,C
            goto         ops
            bcf          INTCON,GIE
            call         offreg
            clrf         slpshet
            bcf          INTCON,RAIF
            bsf          INTCON,RAIE
            SLEEP
            bcf          INTCON,RAIE
            bsf          INTCON,GIE
mk3         call         pauskn
            btfss        start
            goto         mk3

ops         btfsc       rht
            goto        aa1
            btfsc       flag1,5
            goto        aa1
            bsf         flag3,2 ;;;;;;;;
            clrf        flag1
            bsf         flag1,0
            bsf         flag1,4
            goto        preriv
aa1         btfsc       lft
            goto        aa2
            btfsc       flag1,4
            goto        aa2
            bsf         flag3,2 ;;;;;;;;
            clrf        flag1
            bsf         flag1,1
            bsf         flag1,5
            goto        preriv
aa2         btfsc       dwn
            goto        aa3
            btfss       flag3,2  ;;;;;;;;;
            goto        aa3
            btfsc       flag1,7
            goto        aa3
            clrf        flag1
            bsf         flag1,2
            bsf         flag1,6
            goto        preriv
aa3         btfsc       up
            goto        aa4
            btfsc       flag1,6
            goto        aa4
            bsf         flag3,2 ;;;;;;;;
            clrf        flag1
            bsf         flag1,3
            bsf         flag1,7
            goto        preriv
aa4         btfsc       start
            goto        aa6
            btfss       flag3,2
            goto        aa6
            bcf         T1CON,TMR1ON

aa7         call        pauskn
            btfss       start
            goto        aa7

            clrf         slpshet
            bcf         flag3,2
            bsf         T1CON,TMR1ON
aa08        movf         slpshet,W
            sublw        .240
            btfsc        STATUS,C
            goto         aa8
            bcf          INTCON,GIE
            call         offreg
            clrf         slpshet
            bcf          INTCON,RAIF
            bsf          INTCON,RAIE
            SLEEP
            bcf          INTCON,RAIE
            bsf          INTCON,GIE
mk4         call         pauskn
            btfss        start
            goto         mk4

aa8         call        pauskn
            btfsc       start
            goto        aa08
            
aa9         call        pauskn
            btfss       start
            goto        aa9
            bsf         flag3,2
            movlw       .4
            movwf       flag2
            bcf         flag,0

aa6         btfss       flag,0
            goto        ops1
            bcf         flag,0  
            return


preriv      btfss       flag,0
            goto        preriv
            bcf         flag,0
            return

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;



;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;


koreda       movlw      .1
             movwf      Sec0
             movlw      .10
             call       psrand
             movf       TMR0,W
             movwf      perem
             swapf      perem,F
             movf       TMR1L,W
             movwf      perem1
             movlw        .4
            movwf        var1
ll1         rrf          perem1,F
            rrf          perem,F
            decfsz       var1,F
            goto         ll1
             bcf        perem,7
             movf       kolxy,W
             movwf      perem1
             movlw      dataxy
             movwf      FSR
df1          movf       perem,W
             subwf      INDF,W
             btfsc      STATUS,Z
             goto       koreda
             incf       FSR,F
             decfsz     perem1,F
             goto       df1 

             btfsc      flag3,2
             goto       df2
             movlw      b'00111011'
             subwf      perem,W
             btfsc      STATUS,Z
             goto       koreda
             movlw      b'00101010'
             subwf      perem,W
             btfsc      STATUS,Z
             goto       koreda
             movlw      b'01001010'
             subwf      perem,W
             btfsc      STATUS,Z
             goto       koreda
             goto       finend

df2         movlw       dataxy
            movwf       FSR
            btfss        flag1,0
            goto         g2
gg6         movf         INDF,W
            movwf        perem1
            swapf        perem1,F
            movf         perem1,W
            movwf        tmp
            movlw        b'00001111'
            andwf        tmp,F
            incf         tmp,F
            movlw        .8
            subwf        tmp,W
            btfss        STATUS,Z
            goto         ga2
            btfsc        flag,1
            goto         finend
            clrf         tmp
ga2         movlw        .4
            movwf        var1
ga3         rrf          tmp,F
            rrf          perem1,F
            decfsz       var1,F
            goto         ga3
            movf         perem1,W
            subwf        perem,W
            btfsc        STATUS,Z
            goto         koreda
            goto         finend


g2          btfss        flag1,1
            goto         g3
gg7         movf         INDF,W
            movwf        perem1
            swapf        perem1,F
            movf         perem1,W
            movwf        tmp
            movlw        b'00001111'
            andwf        tmp,F
            decf         tmp,F
            movlw        .255
            subwf        tmp,W
            btfss        STATUS,Z
            goto         gb1
            btfsc        flag,1
            goto         finend
            movlw        .7
            movwf        tmp
gb1         movlw        .4
            movwf        var1
gb2         rrf          tmp,F
            rrf          perem1,F
            decfsz       var1,F
            goto         gb2
            movf         perem1,W
            subwf        perem,W
            btfsc        STATUS,Z
            goto         koreda
            goto         finend


g3          btfss        flag1,2
            goto         g4
gg8         movf         INDF,W
            movwf        tmp
            movwf        perem1
            swapf        perem1,F
            movlw        b'00001111'
            andwf        tmp,F
            decf         tmp,F
            movlw        .255
            subwf        tmp,W
            btfss        STATUS,Z
            goto         gc1
            btfsc        flag,1
            goto         finend
            movlw        .15
            movwf        tmp
gc1         swapf        tmp,F
            movlw        .4
            movwf        var1
gc2         rlf          tmp,F
            rlf          perem1,F
            decfsz       var1,F
            goto         gc2
            movf         perem1,W
            subwf        perem,W
            btfsc        STATUS,Z
            goto         koreda
            goto         finend

g4          btfss        flag1,3
            goto         g5
gg9         movf         INDF,W
            movwf        tmp
            movwf        perem1
            swapf        perem1,F
            movlw        b'00001111'
            andwf        tmp,F
            incf         tmp,F
            movlw        .16
            subwf        tmp,W
            btfss        STATUS,Z
            goto         gd1
            btfsc        flag,1
            goto         finend       
            clrf         tmp
gd1         swapf        tmp,F
            movlw        .4
            movwf        var1
gd2         rlf          tmp,F
            rlf          perem1,F
            decfsz       var1,F
            goto         gd2
            movf         perem1,W
            subwf        perem,W
            btfsc        STATUS,Z
            goto         koreda
            goto         finend

g5          btfsc        flag1,4
            goto         gg6
            btfsc        flag1,5
            goto         gg7
            btfsc        flag1,6
            goto         gg8
            goto         gg9

finend       movlw       dataxy
             movwf       FSR
             movf       kolxy,W
             addwf      FSR,F
             movf       perem,W
             movwf      INDF
             incf       kolxy,F
             return


;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;


;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

nachkor     movlw       .2
            movwf       kolxy
            movf        dlin,W
            movwf       perem1
            movlw       dataxy
            movwf       FSR
            movlw       b'00111010'
            movwf       INDF
            incf        FSR,F
            movlw       b'00111001'
            movwf       INDF
bb1         movf        INDF,W
            movwf       perem
            movlw       b'00001111'
            andwf       perem,F
            movlw       .1
            subwf       perem,F
            bsf         perem,4
            bsf         perem,5
            incf        FSR,F
            movf        perem,W
            movwf       INDF
            incf        kolxy,F
            decfsz      perem1,F
            goto        bb1
            return
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;


vivod       movlw       .255
            movwf       shetx
z1          incf        shetx,F
            movlw       datay
            movwf       FSR
            movf        shetx,W
            addwf       FSR,F
            clrf        INDF
            movlw       .8
            addwf       FSR,F
            clrf        INDF
            movf        kolxy,W
            movwf       kolxytmp
            movlw       dataxy
            movwf       FSR
z2          movf        INDF,W
            movwf       regtmp
            swapf       regtmp,F
            movlw       b'00001111'
            andwf       regtmp,F
            movf        regtmp,W
            subwf       shetx,W
            btfsc       STATUS,Z
            call        ybyte
            incf        FSR,F
            decfsz      kolxytmp,F
            goto        z2
            movlw       .7
            subwf       shetx,W
            btfss       STATUS,Z
            goto        z1
            bsf         flag3,0
            return


ybyte       bcf         INTCON,GIE
            movf        INDF,W
            movwf       regtmp
            movf        FSR,W
            movwf       FSRtmp1
            movlw       b'00001111'
            andwf       regtmp,F
            movf        regtmp,W
            sublw       .7
            btfss       STATUS,C
            goto        z4
            movlw       datay
            movwf       FSR          
            movf        shetx,W
            addwf       FSR,F
            movlw       .255
            movwf       var1
            goto        z5
z4          movlw       datay1
            movwf       FSR          
            movf        shetx,W
            addwf       FSR,F
            movlw       .7
            movwf       var1
z5          movlw       .8
            movwf       var2           
z3          incf        var1,F
            btfsc       STATUS,C
            bsf         flag,6
            btfss       STATUS,C
            bcf         flag,6
            movf        var1,W
            subwf       regtmp,W
            btfsc       STATUS,Z
            bsf         INDF,0
            btfsc       flag,6
            bsf         STATUS,C
            btfss       flag,6
            bcf         STATUS,C
            rrf         INDF,F
            decfsz      var2,F
            goto        z3
            rrf         INDF,F
            movf        FSRtmp1,W
            movwf       FSR   
            bsf         INTCON,GIE     
            return
;;;;;;;;;;;;;;;


;;;;;;;;;;

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

clean        bsf        STATUS,IRP
             movlw      .16
             movwf      perem
             movlw      datayy
             movwf      FSR
             decf       FSR,F
x11          incf       FSR,F
             clrf       INDF
             decfsz     perem,F
             goto       x11
             bcf        STATUS,IRP
             return
 
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
offreg       movlw      .24
             movwf      scetbit
             bcf        data
ii01         bsf        clk
             bcf        clk
             decfsz     scetbit,F
             goto       ii01
            
             bsf        cs
             bcf        cs
             return
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

stenka       bsf        STATUS,IRP
             movlw      .8
             movwf      perem1
             clrf       smehen
yy2          call       pause
             movlw      datayy
             movwf      FSR
             movlw      .8
             movwf      perem
             rlf        smehen,F
             bsf        smehen,0
yy1          movf       smehen,W
             iorwf      INDF,F
             incf       FSR,F
             decfsz     perem,F
             goto       yy1
             decfsz     perem1,F
             goto       yy2

             movlw      .8
             movwf      perem1
             clrf       smehen
yy4          call       pause
             movlw      datayy1
             movwf      FSR
             movlw      .8
             movwf      perem
             rlf        smehen,F
             bsf        smehen,0
yy3          movf       smehen,W
             iorwf      INDF,F
             incf       FSR,F
             decfsz     perem,F
             goto       yy3
             decfsz     perem1,F
             goto       yy4

             movlw      .8
             movwf      perem1
             movlw      .255
             movwf      smehen
yy6          call       pause
             movlw      datayy1
             movwf      FSR
             movlw      .8
             movwf      perem
             rrf        smehen,F
             bcf        smehen,7
yy5          movf       smehen,W
             andwf      INDF,F
             incf       FSR,F
             decfsz     perem,F
             goto       yy5
             decfsz     perem1,F
             goto       yy6

             movlw      .8
             movwf      perem1
             movlw      .255
             movwf      smehen
yy8          call       pause
             movlw      datayy
             movwf      FSR
             movlw      .8
             movwf      perem
             rrf        smehen,F
             bcf        smehen,7
yy7          movf       smehen,W
             andwf      INDF,F
             incf       FSR,F
             decfsz     perem,F
             goto       yy7
             decfsz     perem1,F
             goto       yy8
             bcf        STATUS,IRP
             return
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;    


pauskn         movlw     .148       ; 20 
pstetr         movwf     Sec0       ; 133    . 
p2             movlw     .90
psrand         movwf     Sec
p1             decfsz    Sec,F
               goto      p1
               decfsz    Sec0,F
               goto      p2
               return

pause          movlw     .160       ; 60 
               movwf     Sec0
p12            movlw     .255
               movwf     Sec
p11            decfsz    Sec,F
               goto      p11
               decfsz    Sec0,F
               goto      p12
               return


pause1       movlw       .10       ; 
paus         movwf       Sec0
pld3         movlw       .128
             movwf       Sec1           
pld2         movlw       .255
             movwf       Sec
pld1         decfsz      Sec,F
             goto        pld1
             decfsz      Sec1,F
             goto        pld2
             decfsz      Sec0,F
             goto        pld3
             return
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;


;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

vivdan      clrf         slpshet
            bsf        STATUS,IRP
            movf        dlin,W
            movwf       smehen
            decf        smehen,F
            movf        smehen,W
            addwf       smehen,F
            addwf       smehen,F
            movlw       .3
            movwf       perem
            movlw       datayy1
            movwf       FSR
            movlw       .3
            addwf       FSR,F
v1          call        table
            movwf       INDF
            incf        FSR,F
            incf        smehen,F
            decfsz      perem,F
            goto        v1
           
            movf        skor,W
            movwf       smehen
            decf        smehen,F
            movf        smehen,W
            addwf       smehen,F
            addwf       smehen,F
            movlw       .3
            movwf       perem
            movlw       datayy
            movwf       FSR
            movlw       .3
            addwf       FSR,F
v2          call        table
            movwf       INDF
            rlf         INDF,F
            incf        FSR,F
            incf        smehen,F
            decfsz      perem,F
            goto        v2

            btfsc       flag,1
            goto        v3
            movlw       datayy
            movwf       FSR
            clrf        INDF
            movlw       .6
            movwf       perem
v4          incf        FSR,F
            bcf         INDF,0
            decfsz      perem,F
            goto        v4
            incf        FSR,F
            clrf        INDF
            incf        FSR,F
            clrf        INDF
            movlw       .6
            movwf       perem
v5          incf        FSR,F
            bcf         INDF,7
            decfsz      perem,F
            goto        v5
            incf        FSR,F
            clrf        INDF
            return

v3          movlw       datayy
            movwf       FSR
            movlw       .255
            movwf       INDF
            movlw       .6
            movwf       perem
v6          incf        FSR,F
            bsf         INDF,0
            decfsz      perem,F
            goto        v6
            incf        FSR,F
            movlw       .255
            movwf       INDF
            incf        FSR,F
            movlw       .255
            movwf       INDF
            movlw       .6
            movwf       perem
v7          incf        FSR,F
            bsf         INDF,7
            decfsz      perem,F
            goto        v7
            incf        FSR,F
            movlw       .255
            movwf       INDF
            bcf        STATUS,IRP
            return

table       movlw       high data1
            movwf       PCLATH
            movf        smehen,W
            addlw       low data1
            btfsc       STATUS,C
            incf        PCLATH,F
            movf        smehen,W
            addwf       PCL,F
data1       dt 0x00, 0x10, 0x3E
            dt 0x2E, 0x2A, 0x3A
            dt 0x2A, 0x2A, 0x3E
            dt 0x38, 0x08, 0x3E
            dt 0x3A, 0x2A, 0x2E
            dt 0x3E, 0x2A, 0x2E
            dt 0x30, 0x20, 0x3E
            dt 0x3E, 0x2A, 0x3E
            dt 0x3A, 0x2A, 0x3E
          
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

vivzast     clrf       slpshet
            bsf        STATUS,IRP
            btfsc       flag,5
            goto        ta1
            clrf        smehen
            movlw       .16
            movwf       perem
            movlw       datayy
            movwf       FSR          ;;;;;;;;;;;;;;;;;
           
tt1         call        table3
            movwf       INDF
            incf        FSR,F
            incf        smehen,F
            decfsz      perem,F
            goto        tt1
            return
            
ta1         movlw       .16
            movwf       smehen
            movwf       perem
            movlw       datayy
            movwf       FSR
           
tt2         call        table3
            movwf       INDF
            incf        FSR,F
            incf        smehen,F
            decfsz      perem,F
            goto        tt2
            bcf        STATUS,IRP
            return
            
table3      movlw       high data3
            movwf       PCLATH
            movf        smehen,W
            addlw       low data3
            btfsc       STATUS,C
            incf        PCLATH,F
            movf        smehen,W
            addwf       PCL,F
data3       dt 0x00, 0x8E, 0x0A
            dt 0x8A, 0x08, 0xB8
            dt 0x02, 0x80, 0x01
            dt 0x00, 0x01, 0x24
            dt 0x7D, 0x04, 0x01
            dt 0x00, 0x0F, 0x87
            dt 0x01, 0x83, 0x38
            dt 0x91, 0x03, 0x87
            dt 0x01, 0x00, 0x25
            dt 0x4C, 0x55, 0x24
            dt 0x01, 0x00


;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;


            


tetrbeg     movlw        .1
            movwf        skor
            clrf         ochko
            call         clean

tetr1       bsf          PCLATH,3
            call         vivtetr
           ; goto         began1  ;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

w01         movf         slpshet,W
            sublw        .240
            btfsc        STATUS,C
            goto         w1
            bcf          INTCON,GIE
            call         offreg
            clrf         slpshet
            bcf          INTCON,RAIF
            bsf          INTCON,RAIE
            SLEEP
            bcf          INTCON,RAIE
            bsf          INTCON,GIE
mk5         call         pauskn
            btfss        start
            goto         mk5

w1          btfsc        up
            goto         w2
            incf         skor,F
            movf         skor,W
            sublw        .9
            btfsc        STATUS,C
            goto         ww1
            movlw        .1
            movwf        skor
ww1         bsf          PCLATH,3
            call         vivtetr
ww3         call         pauskn
            btfss        up
            goto         ww3
w2          btfsc        dwn
            goto         w3
            decf         skor,F
            movf         skor,W
            sublw        .0
            btfss        STATUS,Z
            goto         ww2
            movlw        .9
            movwf        skor
ww2         bsf          PCLATH,3
            call         vivtetr
ww4         call         pauskn
            btfss        dwn
            goto         ww4

w3          btfsc        start
            goto         w01
            movlw        .50
            movwf        var
w4          call         pauskn
            btfsc        start
            goto         began
            decfsz       var,F
            goto         w4
            bcf          STATUS,IRP
            bcf          flag,7
            goto         zastav

;began1     movlw        datafig
          ;  movwf        FSR
          ;  movlw        .0
          ;  movwf        INDF
          ;  incf         FSR,F
          ;   movlw        .16
          ;  movwf        INDF
          ;  incf         FSR,F
           ;  movlw        .0
           ; movwf        INDF
         ;  incf         FSR,F
          ;   movlw        .96
         ;   movwf        INDF
         ;  incf         FSR,F
         ;  movlw        .112
          ;  movwf        INDF
           ; incf         FSR,F
            ; movlw        .113
          ;  movwf        INDF
          ;  incf         FSR,F
           ;  movlw        .96
           ; movwf        INDF
          ; incf         FSR,F
          ;   movlw        .112
          ;  movwf        INDF
          


began       clrf         kolxy
            clrf         ochko
            movlw        b'11110000'
            movwf        flag1
            call         stenka
            bsf          flag3,2

           ; movlw        .4   ;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
          ;  movwf        kolxy   ;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

rand       movlw       .4
            movwf       flag2
           bcf         flag,0
           call         random

            movf          INDF,W
            movwf         tmpfig4
            decf          FSR,F
            movf          INDF,W
            movwf         tmpfig3
            decf          FSR,F
            movf          INDF,W
            movwf         tmpfig2
            decf          FSR,F
            movf          INDF,W
            movwf         tmpfig1

            movlw         .0
            subwf         kolxy,W
            btfsc         STATUS,Z
            goto          beg1

            bsf           PCLATH,3
            call          naezdfig
            btfss         flag,3
            goto          beg1
            movlw         .4
            addwf         kolxy,F
            clrf          slpshet
            bcf           flag3,2
            bsf           PCLATH,3
            call          vivodfig
            call          pause1
            call          stenka
            goto          tetr1
            
beg1        movlw         .4
            addwf         kolxy,F
vi1         bsf           PCLATH,3
            call          vivodfig
op1         call          oprosknfig
            call          ust

            ;goto          h4  ;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
            btfss         flag1,0
            goto          h2
            call          rhtfig
            btfsc         flag,1
            goto          hh1
            bsf           PCLATH,3
            call          naezdfig
            btfsc         flag,3
            goto          hh1
            call          ust
            call          perep
            btfsc         rht
            goto          hh2
            bcf           flag1,4
            goto          vi1
hh2         bsf           flag1,4
            goto          vi1
hh1         btfsc         rht
            goto          hh3
            bcf           flag1,4
            goto          op1
hh3         bsf           flag1,4
            goto          op1


h2          btfss         flag1,1
            goto          h3
            bsf           PCLATH,3
            call          lftfig
            btfsc         flag,1
            goto          ha1
            bsf           PCLATH,3
            call          naezdfig
            btfsc         flag,3
            goto          ha1
            call          ust
            call          perep
            btfsc         lft
            goto          ha2
            bcf           flag1,5
            goto          vi1
ha2         bsf           flag1,5
            goto          vi1
ha1         btfsc         rht
            goto          ha3
            bcf           flag1,5
            goto          op1
ha3         bsf           flag1,5
            goto          op1


h3          btfss         flag1,3
            goto          h4
            movlw         .0
            subwf         figur,W
            btfss         STATUS,Z
            goto          hb1
            bsf           PCLATH,3
            call          figura0
            goto          figg
hb1         movlw         .1
            subwf         figur,W
            btfss         STATUS,Z
            goto          hb2
            bsf          PCLATH,3
            call          figura1
            goto          figg
hb2         movlw         .2
            subwf         figur,W
            btfss         STATUS,Z
            goto          hb3
            bsf          PCLATH,3
            call          figura2
            goto          figg
hb3         movlw         .3
            subwf         figur,W
            btfss         STATUS,Z
            goto          hb4
            bsf          PCLATH,3
            call          figura3
            goto          figg
hb4         movlw         .4
            subwf         figur,W
            btfss         STATUS,Z
            goto          hb5
            bsf          PCLATH,3
            call          figura4
            goto          figg
hb5         movlw         .5
            subwf         figur,W
            btfss         STATUS,Z
            goto          hb6
            btfsc         up
            goto          hc1
            bcf           flag1,7
            goto          op1
hc1         bsf           flag1,7
            goto          op1

hb6         bsf          PCLATH,3
            call          figura6

figg        btfsc         flag,1
            goto          nnn2
            bsf           PCLATH,3
            call          naezdfig
            btfsc         flag,3
            goto          hd1
            call          ust
            call          perep
            btfsc         up
            goto          hd2
            bcf           flag1,7
            goto          vi1
hd2         bsf           flag1,7
            goto          vi1

hd1         movlw         .0
            subwf         figur,W
            btfsc         STATUS,Z
            goto          nnn1
            movlw         .1
            subwf         figur,W
            btfsc         STATUS,Z
            goto          nnn1
            movlw         .4
            subwf         figur,W
            btfsc         STATUS,Z
            goto          nnn1
            decfsz        povorot,F
            goto          nnn2
            movlw         .4
            movwf         povorot
            goto          nnn2
nnn1        btfsc         flag,2
            goto          nnn3
            bsf           flag,2
            goto          nnn2
nnn3        bcf           flag,2

nnn2        btfsc         up
            goto          hd3
            bcf           flag1,7
            goto          op1
hd3         bsf           flag1,7
            goto          op1




h4          btfss         flag1,2
            goto          op1
            bsf           PCLATH,3
            call          dwnfig
            btfsc         flag,1
            goto          hk1
            bsf           PCLATH,3
            call          naezdfig
            btfsc         flag,3
            goto          hk1
            call          ust
            call          perep
            movlw         .160
            call          pstetr
            goto          vi1

hk1         bsf           flag3,1
            call          stroka 
            goto          rand
          

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

oprosknfig  movlw        b'11110000'
            
            andwf        flag1,F
           ; bsf          flag,0   ;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
k5          btfss        flag,0
            goto         k1
            bcf          flag,0
            bsf          flag1,2
            return
k1          btfsc        rht
            goto         kk1
            call         pauskn
            btfss        flag1,4
            goto         k2
            bsf          flag1,0
            return
kk1         bsf          flag1,4
k2          btfsc        lft
            goto         kk2
            call         pauskn
            btfss        flag1,5
            goto         k3
            bsf          flag1,1
            return
kk2         bsf          flag1,5
k3          btfsc        up
            goto         kk3
            call         pauskn
            btfss        flag1,7
            goto         k4
            bsf          flag1,3
            return
kk3         bsf          flag1,7
k4          btfsc        dwn
            goto         kk4k
            btfsc        flag3,1
            goto         kk4
            bsf          flag1,2
            return
kk4k        bcf          flag3,1

kk4         btfsc       start
            goto        k5
            bcf         T1CON,TMR1ON
kk5         call        pauskn
            btfss       start
            goto        kk5

            clrf         slpshet
            bcf         flag3,2
            bsf         T1CON,TMR1ON
k08         movf         slpshet,W
            sublw        .240
            btfsc        STATUS,C
            goto         kk6
            bcf          INTCON,GIE
            call         offreg
            clrf         slpshet
            bcf          INTCON,RAIF
            bsf          INTCON,RAIE
            SLEEP
            bcf          INTCON,RAIE
            bsf          INTCON,GIE
mk6         call         pauskn
            btfss        start
            goto         mk6
    
kk6         call        pauskn
            btfsc       start
            goto        k08  
            
kk7         call        pauskn
            btfss       start
            goto        kk7
            bsf         flag3,2
            movlw       .4
            movwf       flag2
            bcf         flag,0
            goto        k5

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;


random      bcf          STATUS,IRP
            movf         TMR0,W
           ; movlw        .0  ;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
            movwf        figur
            movlw        b'00000111'
            andwf        figur,F
            movlw        .7
            subwf        figur,W
            btfsc        STATUS,Z
            decf         figur,F
            movlw        datafig
            movwf        FSR
            movf         kolxy,W
            movwf        kolxytmp
            sublw        .79
            btfsc        STATUS,C
            goto         kkk1
            movlw        .80
            subwf        kolxytmp,F
            bsf          STATUS,IRP
            movlw        datafig1
            movwf        FSR
kkk1        movf         kolxytmp,W
            addwf        FSR,F           
korfig      movf         figur,W
            sublw        .0
            btfss        STATUS,Z
            goto         kkk2
            bcf          flag,2
            movlw        .47
            movwf        INDF
            incf         FSR,F
            movlw        .63
            movwf        INDF
            incf         FSR,F       
            movlw        .79
            movwf        INDF
            incf         FSR,F
            movlw        .95
            movwf        INDF
            return
kkk2        movf         figur,W
            sublw        .1
            btfss        STATUS,Z
            goto         kkk3
            bcf          flag,2
            movlw        .63
            movwf        INDF
            incf         FSR,F
            movlw        .79
            movwf        INDF
            incf         FSR,F       
            movlw        .78
            movwf        INDF
            incf         FSR,F
            movlw        .94
            movwf        INDF
            return
kkk3        movf         figur,W
            sublw        .2
            btfss        STATUS,Z
            goto         kkk4
            movlw        .1
            movwf        povorot
            movlw        .63
            movwf        INDF
            incf         FSR,F
            movlw        .79
            movwf        INDF
            incf         FSR,F       
            movlw        .95
            movwf        INDF
            incf         FSR,F
            movlw        .78
            movwf        INDF
            return 
kkk4        movf         figur,W
            sublw        .3
            btfss        STATUS,Z
            goto         kkk5
            movlw        .1
            movwf        povorot
            movlw        .62
            movwf        INDF
            incf         FSR,F
            movlw        .78
            movwf        INDF
            incf         FSR,F       
            movlw        .94
            movwf        INDF
            incf         FSR,F
            movlw        .95
            movwf        INDF
            return 
kkk5        movf         figur,W
            sublw        .4
            btfss        STATUS,Z
            goto         kkk6
            bcf          flag,2
            movlw        .62
            movwf        INDF
            incf         FSR,F
            movlw        .78
            movwf        INDF
            incf         FSR,F       
            movlw        .79
            movwf        INDF
            incf         FSR,F
            movlw        .95
            movwf        INDF
            return
kkk6        movf         figur,W
            sublw        .5
            btfss        STATUS,Z
            goto         kkk7
            movlw        .63
            movwf        INDF
            incf         FSR,F
            movlw        .79
            movwf        INDF
            incf         FSR,F       
            movlw        .62
            movwf        INDF
            incf         FSR,F
            movlw        .78
            movwf        INDF
            return
kkk7        movlw        .1
            movwf        povorot
            movlw        .63
            movwf        INDF
            incf         FSR,F
            movlw        .62
            movwf        INDF
            incf         FSR,F       
            movlw        .78
            movwf        INDF
            incf         FSR,F
            movlw        .94
            movwf        INDF
            return
           
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

rhtfig     movf          INDF,W
           movwf         tmpfig1
           incf          FSR,F
           movf          INDF,W
           movwf         tmpfig2
           incf          FSR,F
           movf          INDF,W
           movwf         tmpfig3
           incf          FSR,F
           movf          INDF,W
           movwf         tmpfig4
           movlw         tmpfig1
           movwf         FSR
           movlw         .4
           movwf         var2
rh2        swapf        INDF,F
            movf         INDF,W
            movwf        tmp
            movlw        b'00001111'
            andwf        tmp,F
            incf         tmp,F
            movlw        .8
            subwf        tmp,W
            btfsc        STATUS,Z
            goto         nzdst1
            movlw        .4
            movwf        var1
rh1         rrf          tmp,F
            rrf          INDF,F
            decfsz       var1,F
            goto         rh1
            incf         FSR,F
            decfsz       var2,F
            goto         rh2
            bcf          flag,1
            return
nzdst1      bsf          flag,1
            return

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;




;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;


;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

stroka      clrf          var1
s4          bcf           STATUS,IRP
            movlw         datafig
            movwf         FSR
            movf          kolxy,W
            movwf         kolxytmp
            clrf          var2
s3          movf          INDF,W
            movwf         tmp
            movlw         b'00001111'
            andwf         tmp,F
            movf          var1,W
            subwf         tmp,F
            btfss         STATUS,Z
            goto          s1
            incf          var2,F
            movlw         .8
            subwf         var2,W
            btfsc         STATUS,Z
            goto          delstroka
s1          incf          FSR,F
            movlw         0xF0
            subwf         FSR,W
            btfss         STATUS,Z
            goto          s2
            bsf           STATUS,IRP
            movlw         datafig1
            movwf         FSR
s2          decfsz        kolxytmp,F
            goto          s3
            movlw         .15
            subwf         var1,W
            btfsc         STATUS,Z
            return
            incf          var1,F
            goto          s4

delstroka   btfsc         STATUS,IRP
            bsf           flag,4
            btfss         STATUS,IRP
            bcf           flag,4
            incf          ochko,F
            movlw         .99
            subwf         ochko,W
            btfss         STATUS,Z
            goto          yya3
            movlw         .1
            movwf         ochko        
yya3        bcf           STATUS,IRP
            movlw         datafig
            movwf         FSR
            movf          kolxy,W
            movwf         kolxytmp
yya2        movf          INDF,W
            movwf         tmp
            movlw         b'00001111'
            andwf         tmp,F
            movf          var1,W
            subwf         tmp,F
            btfsc         STATUS,Z
            goto          yya1
            decf          kolxytmp,F

            incf          FSR,F
            movlw         0xF0
            subwf         FSR,W
            btfss         STATUS,Z
            goto          yya2
            bsf           STATUS,IRP
            movlw         datafig1
            movwf         FSR

            goto          yya2
yya1        decfsz        kolxytmp,F
            goto          y1
            decf          kolxy,F
            decfsz        var2,F
            goto          yya3
            movlw         .0
            subwf         kolxy,W
            btfsc         STATUS,Z
            return
            goto          perp

y1          incf          FSR,F
            movlw         0xF0
            subwf         FSR,W
            btfss         STATUS,Z
            goto          y2
            bsf           STATUS,IRP
            movlw         datafig1
            movwf         FSR

y2          movf          INDF,W
            movwf         spec
            decf          FSR,F
            
            movlw         0x1F
            subwf         FSR,W
            btfss         STATUS,Z
            goto          y3
            bcf           STATUS,IRP
            movlw         0xEF
            movwf         FSR

y3          movf          spec,W
            movwf         INDF
            incf          FSR,F

            movlw         0xF0
            subwf         FSR,W
            btfss         STATUS,Z
            goto          y4
            bsf           STATUS,IRP
            movlw         datafig1
            movwf         FSR

y4          decfsz        kolxytmp,F
            goto          y1
            decf          kolxy,F
            decfsz        var2,F
            goto          yya3
            movlw         .0
            subwf         kolxy,W
            btfsc         STATUS,Z
            return

perp        bcf           STATUS,IRP
            movlw         datafig
            movwf         FSR
            movf          kolxy,W
            movwf         kolxytmp
x4          movf          INDF,W
            movwf         tmp
            movlw         b'00001111'
            andwf         tmp,F
            movf          tmp,W
            subwf         var1,W
            btfsc         STATUS,C
            goto          x1
            decf          tmp,F
            swapf         tmp,F
            swapf         INDF,F
            movlw         .4
            movwf         var2 
x2          rlf           tmp,F
            rlf           INDF,F
            decfsz        var2,F
            goto          x2
x1          decfsz        kolxytmp,F
            goto          x3
            btfsc         flag,4
            bsf           STATUS,IRP
            btfss         flag,4
            bcf           STATUS,IRP
            goto          stroka
x3          incf          FSR,F
            movlw         0xF0
            subwf         FSR,W
            btfss         STATUS,Z
            goto          x4
            bsf           STATUS,IRP
            movlw         datafig1
            movwf         FSR
            goto          x4



;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;


;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

            


;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

ust         bcf         STATUS,IRP
            movlw       datafig
            movwf       FSR
            movf         kolxy,W
            movwf        kolxytmp
            sublw        .83
            btfsc        STATUS,C
            goto         u1
            movlw        .80
            subwf        kolxytmp,F
            bsf          STATUS,IRP
            movlw        datafig1
            movwf        FSR
u1          movf         kolxytmp,W
            addwf        FSR,F
            movlw        .4
            subwf         FSR,F
            return      

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

perep      movf          tmpfig1,W
           movwf         INDF
           incf          FSR,F
           movf          tmpfig2,W
           movwf         INDF
           incf          FSR,F
           movf          tmpfig3,W
           movwf         INDF
           incf          FSR,F
           movf          tmpfig4,W
           movwf         INDF
           return
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;


            org         0800h

lftfig     movf          INDF,W
           movwf         tmpfig1
           incf          FSR,F
           movf          INDF,W
           movwf         tmpfig2
           incf          FSR,F
           movf          INDF,W
           movwf         tmpfig3
           incf          FSR,F
           movf          INDF,W
           movwf         tmpfig4
           movlw         tmpfig1
           movwf         FSR
           movlw         .4
           movwf         var2
lf2        swapf         INDF,F
            movf         INDF,W
            movwf        tmp
            movlw        b'00001111'
            andwf        tmp,F
            decf         tmp,F
            movlw        .255
            subwf        tmp,W
            btfsc        STATUS,Z
            goto         nzdst2
            movlw        .4
            movwf        var1
lf1         rrf          tmp,F
            rrf          INDF,F
            decfsz       var1,F
            goto         lf1
            incf         FSR,F
            decfsz       var2,F
            goto         lf2
            bcf          flag,1
            bcf         PCLATH,3
            return
nzdst2      bsf          flag,1
            bcf         PCLATH,3
            return


dwnfig     movf          INDF,W
           movwf         tmpfig1
           incf          FSR,F
           movf          INDF,W
           movwf         tmpfig2
           incf          FSR,F
           movf          INDF,W
           movwf         tmpfig3
           incf          FSR,F
           movf          INDF,W
           movwf         tmpfig4
           movlw         tmpfig1
           movwf         FSR
           movlw         .4
           movwf         var2
dn2        movf         INDF,W
            movwf        tmp
            swapf        INDF,F
            movlw        b'00001111'
            andwf        tmp,F
            decf         tmp,F
            movlw        .255
            subwf        tmp,W         
            btfsc        STATUS,Z
            goto         nzdst3
            swapf        tmp,F
            movlw        .4
            movwf        var1
dn1         rlf          tmp,F
            rlf          INDF,F
            decfsz       var1,F
            goto         dn1
            incf         FSR,F
            decfsz       var2,F
            goto         dn2
            bcf          flag,1
            bcf         PCLATH,3
            return
nzdst3      bsf          flag,1
            bcf         PCLATH,3
            return

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

vivodfig    movlw       .255
            movwf       shetx
zz1         bcf         STATUS,IRP
            incf        shetx,F
            movlw       datay
            movwf       FSR
            movf        shetx,W
            addwf       FSR,F
            clrf        INDF
            movlw       .8
            addwf       FSR,F
            clrf        INDF
            movf        kolxy,W
            movwf       kolxytmp
            movlw       datafig
            movwf       FSR
zz2         movf        INDF,W
            movwf       regtmp
            swapf       regtmp,F
            movlw       b'00001111'
            andwf       regtmp,F
            movf        regtmp,W
            subwf       shetx,W
            btfsc       STATUS,Z
            call        ybyte1
            incf        FSR,F

            movlw        0xF0
            subwf        FSR,W
            btfss        STATUS,Z
            goto         zz6
            bsf          STATUS,IRP
            movlw        datafig1
            movwf        FSR

zz6         decfsz      kolxytmp,F
            goto        zz2
            movlw       .7
            subwf       shetx,W
            btfss       STATUS,Z
            goto        zz1
            bsf         flag3,0
            bcf         PCLATH,3
            return


ybyte1      bcf         INTCON,GIE
            movf        INDF,W
            movwf       regtmp
            movf        FSR,W
            movwf       FSRtmp1
            btfsc       STATUS,IRP
            bsf         flag,4
            btfss       STATUS,IRP           
            bcf         flag,4
            bcf         STATUS,IRP
            movlw       b'00001111'
            andwf       regtmp,F
            movf        regtmp,W
            sublw       .7
            btfss       STATUS,C
            goto        zz4
            movlw       datay
            movwf       FSR          
            movf        shetx,W
            addwf       FSR,F
            movlw       .255
            movwf       var1
            goto        zz5
zz4         movlw       datay1
            movwf       FSR          
            movf        shetx,W
            addwf       FSR,F
            movlw       .7
            movwf       var1
zz5         movlw       .8
            movwf       var2           
zz3         incf        var1,F
            btfsc       STATUS,C
            bsf         flag,6
            btfss       STATUS,C
            bcf         flag,6
            movf        var1,W
            subwf       regtmp,W
            btfsc       STATUS,Z
            bsf         INDF,0
            btfsc       flag,6
            bsf         STATUS,C
            btfss       flag,6
            bcf         STATUS,C
            rrf         INDF,F
            decfsz      var2,F
            goto        zz3
            rrf         INDF,F
            movf        FSRtmp1,W
            movwf       FSR
            btfsc       flag,4
            bsf         STATUS,IRP
            btfss       flag,4
            bcf         STATUS,IRP
            bsf         INTCON,GIE
            return


;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

          

naezdfig    bcf          STATUS,IRP
            movlw        datafig
            movwf        FSR
            movf         kolxy,W
            movwf        kolxytmp
            movlw        .4
            subwf        kolxytmp,F
            btfsc        STATUS,Z
            goto         ex55
nn2         movf         tmpfig1,W
            subwf        INDF,W
            btfsc        STATUS,Z
            goto         nzd
            incf         FSR,F
            movlw        0xF0
            subwf        FSR,W
            btfss        STATUS,Z
            goto         nn1
            bsf          STATUS,IRP
            movlw        datafig1
            movwf        FSR
nn1         decfsz       kolxytmp,F
            goto         nn2

            bcf          STATUS,IRP
            movlw        datafig
            movwf        FSR
            movf         kolxy,W
            movwf        kolxytmp
            movlw        .4
            subwf        kolxytmp,F
            btfsc        STATUS,Z
            goto         ex55
nn3         movf         tmpfig2,W
            subwf        INDF,W
            btfsc        STATUS,Z
            goto         nzd
            incf         FSR,F
            movlw        0xF0
            subwf        FSR,W
            btfss        STATUS,Z
            goto         nn4
            bsf          STATUS,IRP
            movlw        datafig1
            movwf        FSR
nn4         decfsz       kolxytmp,F
            goto         nn3

            bcf          STATUS,IRP
            movlw        datafig
            movwf        FSR
            movf         kolxy,W
            movwf        kolxytmp
            movlw        .4
            subwf        kolxytmp,F
            btfsc        STATUS,Z
            goto         ex55
nn5         movf         tmpfig3,W
            subwf        INDF,W
            btfsc        STATUS,Z
            goto         nzd
            incf         FSR,F
            movlw        0xF0
            subwf        FSR,W
            btfss        STATUS,Z
            goto         nn6
            bsf          STATUS,IRP
            movlw        datafig1
            movwf        FSR
nn6         decfsz       kolxytmp,F
            goto         nn5

            bcf          STATUS,IRP
            movlw        datafig
            movwf        FSR
            movf         kolxy,W
            movwf        kolxytmp
            movlw        .4
            subwf        kolxytmp,F
            btfsc        STATUS,Z
            goto         ex55
nn7         movf         tmpfig4,W
            subwf        INDF,W
            btfsc        STATUS,Z
            goto         nzd
            incf         FSR,F
            movlw        0xF0
            subwf        FSR,W
            btfss        STATUS,Z
            goto         nn8
            bsf          STATUS,IRP
            movlw        datafig1
            movwf        FSR
nn8         decfsz       kolxytmp,F
            goto         nn7
ex55        bcf          flag,3
            bcf          PCLATH,3
            return
nzd         bsf          flag,3
            bcf          PCLATH,3
            return

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;


            

vivtetr     clrf        slpshet
            bsf         STATUS,IRP
            movf        skor,W
            movwf       smehen
            movf        smehen,W
            addwf       smehen,F
            addwf       smehen,F
            movlw       .3
            movwf       perem
            movlw       datayy
            movwf       FSR
            movlw       .3
            addwf       FSR,F
yyy1        call        table2
            movwf       INDF
            rlf         INDF,F
            incf        FSR,F
            incf        smehen,F
            decfsz      perem,F
            goto        yyy1
           
            movf        ochko,W
            movwf       var

            clrf        sotni
pr0         incf        sotni,F ; 
            movlw       .100
            subwf       var,F
            btfsc       STATUS,C
            goto        pr0
            decf        sotni,F
            movlw       .100
            addwf       var,F
            clrf        desiat
pr1         incf        desiat,F ; 
            movlw       .10
            subwf       var,F
            btfsc       STATUS,C
            goto        pr1
            decf        desiat,F
            movlw       .10
            addwf       var,F
            clrf        edin
pr2         incf        edin,F ; 
            movlw       .1
            subwf       var,F
            btfsc       STATUS,C
            goto        pr2
            decf        edin,F

            movf        desiat,W
            movwf       smehen
            movf        smehen,W
            addwf       smehen,F
            addwf       smehen,F
            movlw       .3
            movwf       perem
            movlw       datayy1
            movwf       FSR
ys1         call        table2
            movwf       INDF
            incf        FSR,F
            incf        smehen,F
            decfsz      perem,F
            goto        ys1

            incf        FSR,F
            incf        FSR,F
            movf        edin,W
            movwf       smehen
            movf        smehen,W
            addwf       smehen,F
            addwf       smehen,F
            movlw       .3
            movwf       perem
ys2         call        table2
            movwf       INDF
            incf        FSR,F
            incf        smehen,F
            decfsz      perem,F
            goto        ys2
            bcf         PCLATH,3
            bcf        STATUS,IRP
            return
            
table2      movlw       high data2
            movwf       PCLATH
            movf        smehen,W
            addlw       low data2
            btfsc       STATUS,C
            incf        PCLATH,F
            movf        smehen,W
            addwf       PCL,F
data2       dt 0x3E, 0x22, 0x3E
            dt 0x00, 0x10, 0x3E
            dt 0x2E, 0x2A, 0x3A
            dt 0x2A, 0x2A, 0x3E
            dt 0x38, 0x08, 0x3E
            dt 0x3A, 0x2A, 0x2E
            dt 0x3E, 0x2A, 0x2E
            dt 0x30, 0x20, 0x3E
            dt 0x3E, 0x2A, 0x3E
            dt 0x3A, 0x2A, 0x3E

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

figura0     movf          INDF,W
            movwf         tmpfig1
            incf          FSR,F
            movf          INDF,W
            movwf         tmpfig2
            incf          FSR,F
            movf          INDF,W
            movwf         tmpfig3
            incf          FSR,F
            movf          INDF,W
            movwf         tmpfig4
            movlw         tmpfig1
            movwf         FSR
            btfsc         flag,2
            goto          fig12

            movf          INDF,W
            movwf         tmp
            swapf         INDF,W
            movwf         var1
            movlw         b'00001111'
            andwf         var1,F
            incf          var1,F
            movlw         b'00001111'
            andwf         tmp,F
            incf          tmp,F
            movlw         .16
            subwf         tmp,W
            btfsc         STATUS,Z
            goto          fig1
            swapf         tmp,W
            movwf         INDF
            movlw         .4
            movwf         var2
fff1        rrf           var1,F
            rrf           INDF,F
            decfsz        var2,F
            goto          fff1

            incf          FSR,F
            incf          FSR,F
            movf          INDF,W
            movwf         tmp
            swapf         INDF,W
            movwf         var1
            movlw         b'00001111'
            andwf         var1,F
            decf          var1,F
            movlw         b'00001111'
            andwf         tmp,F
            decf          tmp,F
            movlw         .255
            subwf         tmp,W
            btfsc         STATUS,Z
            goto          fig1
            swapf         tmp,W
            movwf         INDF
            movlw         .4
            movwf         var2
fff2        rrf           var1,F
            rrf           INDF,F
            decfsz        var2,F
            goto          fff2

            incf          FSR,F
            movf          INDF,W
            movwf         tmp
            swapf         INDF,W
            movwf         var1
            movlw         b'00001111'
            andwf         var1,F
            decf          var1,F
            decf          var1,F
            movlw         b'00001111'
            andwf         tmp,F
            decf          tmp,F
            decf          tmp,F
            movf          tmp,W
            sublw         .253
            btfss         STATUS,C
            goto          fig1
            swapf         tmp,W
            movwf         INDF
            movlw         .4
            movwf         var2
fff3        rrf           var1,F
            rrf           INDF,F
            decfsz        var2,F
            goto          fff3
            bcf           flag,1
            bsf           flag,2
            bcf           PCLATH,3
            return

fig12       movf          INDF,W
            movwf         tmp
            swapf         INDF,W
            movwf         var1
            movlw         b'00001111'
            andwf         var1,F
            decf          var1,F
            movlw         .255
            subwf         var1,W
            btfsc         STATUS,Z
            goto          fig1
            movlw         b'00001111'
            andwf         tmp,F
            decf          tmp,F     
            swapf         tmp,W
            movwf         INDF
            movlw         .4
            movwf         var2
fff4        rrf           var1,F
            rrf           INDF,F
            decfsz        var2,F
            goto          fff4

            incf          FSR,F
            incf          FSR,F
            movf          INDF,W
            movwf         tmp
            swapf         INDF,W
            movwf         var1
            movlw         b'00001111'
            andwf         var1,F
            incf          var1,F
            movlw         .8
            subwf         var1,W
            btfsc         STATUS,Z
            goto          fig1
            movlw         b'00001111'
            andwf         tmp,F
            incf          tmp,F     
            swapf         tmp,W
            movwf         INDF
            movlw         .4
            movwf         var2
fff5        rrf           var1,F
            rrf           INDF,F
            decfsz        var2,F
            goto          fff5

            incf          FSR,F
            movf          INDF,W
            movwf         tmp
            swapf         INDF,W
            movwf         var1
            movlw         b'00001111'
            andwf         var1,F
            incf          var1,F
            incf          var1,F
            movf          var1,W
            sublw         .7
            btfss         STATUS,C
            goto          fig1
            movlw         b'00001111'
            andwf         tmp,F
            incf          tmp,F
            incf          tmp,F     
            swapf         tmp,W
            movwf         INDF
            movlw         .4
            movwf         var2
fff6        rrf           var1,F
            rrf           INDF,F
            decfsz        var2,F
            goto          fff6
            bcf           flag,1
            bcf           flag,2
            bcf           PCLATH,3
            return
fig1        bsf           flag,1
            bcf           PCLATH,3
            return
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

figura1     movf          INDF,W
            movwf         tmpfig1
            incf          FSR,F
            movf          INDF,W
            movwf         tmpfig2
            incf          FSR,F
            movf          INDF,W
            movwf         tmpfig3
            incf          FSR,F
            movf          INDF,W
            movwf         tmpfig4
            movlw         tmpfig1
            movwf         FSR
            btfsc         flag,2
            goto          fig22

            movf          INDF,W
            movwf         tmp
            swapf         INDF,W
            movwf         var1
            movlw         b'00001111'
            andwf         var1,F
            incf          var1,F
            incf          var1,F
            movlw         b'00001111'
            andwf         tmp,F           
            swapf         tmp,W
            movwf         INDF
            movlw         .4
            movwf         var2
fff7        rrf           var1,F
            rrf           INDF,F
            decfsz        var2,F
            goto          fff7

            incf          FSR,F
            movf          INDF,W
            movwf         tmp
            swapf         INDF,W
            movwf         var1
            movlw         b'00001111'
            andwf         var1,F
            incf          var1,F
            movlw         b'00001111'
            andwf         tmp,F
            decf          tmp,F
            swapf         tmp,W
            movwf         INDF
            movlw         .4
            movwf         var2
fff8        rrf           var1,F
            rrf           INDF,F
            decfsz        var2,F
            goto          fff8

            incf          FSR,F
            incf          FSR,F
            movf          INDF,W
            movwf         tmp
            swapf         INDF,W
            movwf         var1
            movlw         b'00001111'
            andwf         var1,F
            decf          var1,F
            movlw         b'00001111'
            andwf         tmp,F
            decf          tmp,F
            movlw         .255
            subwf         tmp,W
            btfsc         STATUS,Z
            goto          fig2
            swapf         tmp,W
            movwf         INDF
            movlw         .4
            movwf         var2
fff9        rrf           var1,F
            rrf           INDF,F
            decfsz        var2,F
            goto          fff9
            bcf           flag,1
            bsf           flag,2
            bcf           PCLATH,3
            return

fig22       movf          INDF,W
            movwf         tmp
            swapf         INDF,W
            movwf         var1
            movlw         b'00001111'
            andwf         var1,F
            decf          var1,F
            decf          var1,F
            movlw         .255
            subwf         var1,W
            btfsc         STATUS,Z
            goto          fig2
            movlw         b'00001111'
            andwf         tmp,F           
            swapf         tmp,W
            movwf         INDF
            movlw         .4
            movwf         var2
fff10       rrf           var1,F
            rrf           INDF,F
            decfsz        var2,F
            goto          fff10

            incf          FSR,F
            movf          INDF,W
            movwf         tmp
            swapf         INDF,W
            movwf         var1
            movlw         b'00001111'
            andwf         var1,F
            decf          var1,F
            movlw         b'00001111'
            andwf         tmp,F
            incf          tmp,F
            swapf         tmp,W
            movwf         INDF
            movlw         .4
            movwf         var2
fff11       rrf           var1,F
            rrf           INDF,F
            decfsz        var2,F
            goto          fff11

            incf          FSR,F
            incf          FSR,F
            movf          INDF,W
            movwf         tmp
            swapf         INDF,W
            movwf         var1
            movlw         b'00001111'
            andwf         var1,F
            incf          var1,F
            movlw         b'00001111'
            andwf         tmp,F
            incf          tmp,F
            swapf         tmp,W
            movwf         INDF
            movlw         .4
            movwf         var2
fff12       rrf           var1,F
            rrf           INDF,F
            decfsz        var2,F
            goto          fff12
            bcf           flag,1
            bcf           flag,2
            bcf           PCLATH,3
            return
fig2        bsf           flag,1
            bcf           PCLATH,3
            return

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

figura2     movf          INDF,W
            movwf         tmpfig1
            incf          FSR,F
            movf          INDF,W
            movwf         tmpfig2
            incf          FSR,F
            movf          INDF,W
            movwf         tmpfig3
            incf          FSR,F
            movf          INDF,W
            movwf         tmpfig4
            movlw         tmpfig1
            movwf         FSR
            movlw         .1
            subwf         povorot,W
            btfsc         STATUS,Z
            goto          fig31
            movlw         .2
            subwf         povorot,W
            btfsc         STATUS,Z
            goto          fig32
            movlw         .3
            subwf         povorot,W
            btfsc         STATUS,Z
            goto          fig33
            goto          fig34

fig31       movf          INDF,W
            movwf         tmp
            swapf         INDF,W
            movwf         var1
            movlw         b'00001111'
            andwf         var1,F
            incf          var1,F
            movlw         b'00001111'
            andwf         tmp,F
            incf          tmp,F 
            movlw         .16
            subwf         tmp,W
            btfsc         STATUS,Z
            goto          fig3          
            swapf         tmp,W
            movwf         INDF
            movlw         .4
            movwf         var2
fff13       rrf           var1,F
            rrf           INDF,F
            decfsz        var2,F
            goto          fff13

            incf          FSR,F
            incf          FSR,F
            movf          INDF,W
            movwf         tmp
            swapf         INDF,W
            movwf         var1
            movlw         b'00001111'
            andwf         var1,F
            decf          var1,F
            movlw         b'00001111'
            andwf         tmp,F 
            decf          tmp,F     
            swapf         tmp,W
            movwf         INDF
            movlw         .4
            movwf         var2
fff14       rrf           var1,F
            rrf           INDF,F
            decfsz        var2,F
            goto          fff14

            incf          FSR,F
            movf          INDF,W
            movwf         tmp
            swapf         INDF,W
            movwf         var1
            movlw         b'00001111'
            andwf         var1,F
            decf          var1,F
            movlw         b'00001111'
            andwf         tmp,F 
            incf          tmp,F     
            swapf         tmp,W
            movwf         INDF
            movlw         .4
            movwf         var2
fff15       rrf           var1,F
            rrf           INDF,F
            decfsz        var2,F
            goto          fff15
            bcf           flag,1
            incf          povorot,F
            bcf           PCLATH,3
            return

fig32       movf          INDF,W
            movwf         tmp
            swapf         INDF,W
            movwf         var1
            movlw         b'00001111'
            andwf         var1,F
            incf          var1,F
            movlw         .8
            subwf         var1,W
            btfsc         STATUS,Z
            goto          fig3    
            movlw         b'00001111'
            andwf         tmp,F
            decf          tmp,F       
            swapf         tmp,W
            movwf         INDF
            movlw         .4
            movwf         var2
fff16       rrf           var1,F
            rrf           INDF,F
            decfsz        var2,F
            goto          fff16

            incf          FSR,F
            incf          FSR,F
            movf          INDF,W
            movwf         tmp
            swapf         INDF,W
            movwf         var1
            movlw         b'00001111'
            andwf         var1,F
            decf          var1,F
            movlw         b'00001111'
            andwf         tmp,F 
            incf          tmp,F     
            swapf         tmp,W
            movwf         INDF
            movlw         .4
            movwf         var2
fff17       rrf           var1,F
            rrf           INDF,F
            decfsz        var2,F
            goto          fff17

            incf          FSR,F
            movf          INDF,W
            movwf         tmp
            swapf         INDF,W
            movwf         var1
            movlw         b'00001111'
            andwf         var1,F
            incf          var1,F
            movlw         b'00001111'
            andwf         tmp,F 
            incf          tmp,F     
            swapf         tmp,W
            movwf         INDF
            movlw         .4
            movwf         var2
fff18       rrf           var1,F
            rrf           INDF,F
            decfsz        var2,F
            goto          fff18
            bcf           flag,1
            incf          povorot,F
            bcf           PCLATH,3
            return

fig33       movf          INDF,W
            movwf         tmp
            swapf         INDF,W
            movwf         var1
            movlw         b'00001111'
            andwf         var1,F
            decf          var1,F          
            movlw         b'00001111'
            andwf         tmp,F
            decf          tmp,F
            movlw         .255
            subwf         tmp,W
            btfsc         STATUS,Z
            goto          fig3           
            swapf         tmp,W
            movwf         INDF
            movlw         .4
            movwf         var2
fff19       rrf           var1,F
            rrf           INDF,F
            decfsz        var2,F
            goto          fff19

            incf          FSR,F
            incf          FSR,F
            movf          INDF,W
            movwf         tmp
            swapf         INDF,W
            movwf         var1
            movlw         b'00001111'
            andwf         var1,F
            incf          var1,F
            movlw         b'00001111'
            andwf         tmp,F 
            incf          tmp,F     
            swapf         tmp,W
            movwf         INDF
            movlw         .4
            movwf         var2
fff20       rrf           var1,F
            rrf           INDF,F
            decfsz        var2,F
            goto          fff20

            incf          FSR,F
            movf          INDF,W
            movwf         tmp
            swapf         INDF,W
            movwf         var1
            movlw         b'00001111'
            andwf         var1,F
            incf          var1,F
            movlw         b'00001111'
            andwf         tmp,F 
            decf          tmp,F     
            swapf         tmp,W
            movwf         INDF
            movlw         .4
            movwf         var2
fff21       rrf           var1,F
            rrf           INDF,F
            decfsz        var2,F
            goto          fff21
            bcf           flag,1
            incf          povorot,F
            bcf           PCLATH,3
            return

fig34       movf          INDF,W
            movwf         tmp
            swapf         INDF,W
            movwf         var1
            movlw         b'00001111'
            andwf         var1,F
            decf          var1,F 
            movlw         .255
            subwf         var1,W
            btfsc         STATUS,Z
            goto          fig3         
            movlw         b'00001111'
            andwf         tmp,F
            incf          tmp,F      
            swapf         tmp,W
            movwf         INDF
            movlw         .4
            movwf         var2
fff22       rrf           var1,F
            rrf           INDF,F
            decfsz        var2,F
            goto          fff22

            incf          FSR,F
            incf          FSR,F
            movf          INDF,W
            movwf         tmp
            swapf         INDF,W
            movwf         var1
            movlw         b'00001111'
            andwf         var1,F
            incf          var1,F
            movlw         b'00001111'
            andwf         tmp,F 
            decf          tmp,F     
            swapf         tmp,W
            movwf         INDF
            movlw         .4
            movwf         var2
fff23       rrf           var1,F
            rrf           INDF,F
            decfsz        var2,F
            goto          fff23

            incf          FSR,F
            movf          INDF,W
            movwf         tmp
            swapf         INDF,W
            movwf         var1
            movlw         b'00001111'
            andwf         var1,F
            decf          var1,F
            movlw         b'00001111'
            andwf         tmp,F 
            decf          tmp,F     
            swapf         tmp,W
            movwf         INDF
            movlw         .4
            movwf         var2
fff24       rrf           var1,F
            rrf           INDF,F
            decfsz        var2,F
            goto          fff24
            bcf           flag,1
            movlw         .1
            movwf         povorot
            bcf           PCLATH,3
            return
fig3        bsf           flag,1
            bcf           PCLATH,3
            return

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

figura3     movf          INDF,W
            movwf         tmpfig1
            incf          FSR,F
            movf          INDF,W
            movwf         tmpfig2
            incf          FSR,F
            movf          INDF,W
            movwf         tmpfig3
            incf          FSR,F
            movf          INDF,W
            movwf         tmpfig4
            movlw         tmpfig1
            movwf         FSR
            movlw         .1
            subwf         povorot,W
            btfsc         STATUS,Z
            goto          fig41
            movlw         .2
            subwf         povorot,W
            btfsc         STATUS,Z
            goto          fig42
            movlw         .3
            subwf         povorot,W
            btfsc         STATUS,Z
            goto          fig43
            goto          fig44

fig41       movf          INDF,W
            movwf         tmp
            swapf         INDF,W
            movwf         var1
            movlw         b'00001111'
            andwf         var1,F
            incf          var1,F
            movlw         b'00001111'
            andwf         tmp,F
            incf          tmp,F     
            swapf         tmp,W
            movwf         INDF
            movlw         .4
            movwf         var2
fff25       rrf           var1,F
            rrf           INDF,F
            decfsz        var2,F
            goto          fff25

            incf          FSR,F
            incf          FSR,F
            movf          INDF,W
            movwf         tmp
            swapf         INDF,W
            movwf         var1
            movlw         b'00001111'
            andwf         var1,F
            decf          var1,F
            movlw         b'00001111'
            andwf         tmp,F 
            decf          tmp,F
            movlw         .255
            subwf         tmp,W
            btfsc         STATUS,Z
            goto          fig4       
            swapf         tmp,W
            movwf         INDF
            movlw         .4
            movwf         var2
fff26       rrf           var1,F
            rrf           INDF,F
            decfsz        var2,F
            goto          fff26

            incf          FSR,F
            movf          INDF,W
            movwf         tmp
            swapf         INDF,W
            movwf         var1
            movlw         b'00001111'
            andwf         var1,F
            movlw         b'00001111'
            andwf         tmp,F 
            decf          tmp,F
            decf          tmp,F
            movlw         .255
            subwf         tmp,W
            btfsc         STATUS,Z
            goto          fig4          
            swapf         tmp,W
            movwf         INDF
            movlw         .4
            movwf         var2
fff27       rrf           var1,F
            rrf           INDF,F
            decfsz        var2,F
            goto          fff27
            bcf           flag,1
            incf          povorot,F
            bcf           PCLATH,3
            return

fig42       movf          INDF,W
            movwf         tmp
            swapf         INDF,W
            movwf         var1
            movlw         b'00001111'
            andwf         var1,F
            incf          var1,F 
            movlw         b'00001111'
            andwf         tmp,F
            decf          tmp,F       
            swapf         tmp,W
            movwf         INDF
            movlw         .4
            movwf         var2
fff28       rrf           var1,F
            rrf           INDF,F
            decfsz        var2,F
            goto          fff28

            incf          FSR,F
            incf          FSR,F
            movf          INDF,W
            movwf         tmp
            swapf         INDF,W
            movwf         var1
            movlw         b'00001111'
            andwf         var1,F
            decf          var1,F
            movlw         .255
            subwf         var1,W
            btfsc         STATUS,Z
            goto          fig4 
            movlw         b'00001111'
            andwf         tmp,F 
            incf          tmp,F     
            swapf         tmp,W
            movwf         INDF
            movlw         .4
            movwf         var2
fff29       rrf           var1,F
            rrf           INDF,F
            decfsz        var2,F
            goto          fff29

            incf          FSR,F
            movf          INDF,W
            movwf         tmp
            swapf         INDF,W
            movwf         var1
            movlw         b'00001111'
            andwf         var1,F
            decf          var1,F
            decf          var1,F
            movlw         .255
            subwf         var1,W
            btfsc         STATUS,Z
            goto          fig4 
            movlw         b'00001111'
            andwf         tmp,F      
            swapf         tmp,W
            movwf         INDF
            movlw         .4
            movwf         var2
fff30       rrf           var1,F
            rrf           INDF,F
            decfsz        var2,F
            goto          fff30
            bcf           flag,1
            incf          povorot,F
            bcf           PCLATH,3
            return

fig43       movf          INDF,W
            movwf         tmp
            swapf         INDF,W
            movwf         var1
            movlw         b'00001111'
            andwf         var1,F
            decf          var1,F          
            movlw         b'00001111'
            andwf         tmp,F
            decf          tmp,F                     
            swapf         tmp,W
            movwf         INDF
            movlw         .4
            movwf         var2
fff31       rrf           var1,F
            rrf           INDF,F
            decfsz        var2,F
            goto          fff31

            incf          FSR,F
            incf          FSR,F
            movf          INDF,W
            movwf         tmp
            swapf         INDF,W
            movwf         var1
            movlw         b'00001111'
            andwf         var1,F
            incf          var1,F
            movlw         b'00001111'
            andwf         tmp,F 
            incf          tmp,F
            movlw         .16
            subwf         tmp,W
            btfsc         STATUS,Z
            goto          fig4       
            swapf         tmp,W
            movwf         INDF
            movlw         .4
            movwf         var2
fff32       rrf           var1,F
            rrf           INDF,F
            decfsz        var2,F
            goto          fff32

            incf          FSR,F
            movf          INDF,W
            movwf         tmp
            swapf         INDF,W
            movwf         var1
            movlw         b'00001111'
            andwf         var1,F
            movlw         b'00001111'
            andwf         tmp,F 
            incf          tmp,F
            incf          tmp,F
            movlw         .16
            subwf         tmp,W
            btfsc         STATUS,Z
            goto          fig4       
            swapf         tmp,W
            movwf         INDF
            movlw         .4
            movwf         var2
fff33       rrf           var1,F
            rrf           INDF,F
            decfsz        var2,F
            goto          fff33
            bcf           flag,1
            incf          povorot,F
            bcf           PCLATH,3
            return

fig44       movf          INDF,W
            movwf         tmp
            swapf         INDF,W
            movwf         var1
            movlw         b'00001111'
            andwf         var1,F
            decf          var1,F   
            movlw         b'00001111'
            andwf         tmp,F
            incf          tmp,F      
            swapf         tmp,W
            movwf         INDF
            movlw         .4
            movwf         var2
fff34       rrf           var1,F
            rrf           INDF,F
            decfsz        var2,F
            goto          fff34

            incf          FSR,F
            incf          FSR,F
            movf          INDF,W
            movwf         tmp
            swapf         INDF,W
            movwf         var1
            movlw         b'00001111'
            andwf         var1,F
            incf          var1,F
            movlw         .8
            subwf         var1,W
            btfsc         STATUS,Z
            goto          fig4
            movlw         b'00001111'
            andwf         tmp,F 
            decf          tmp,F     
            swapf         tmp,W
            movwf         INDF
            movlw         .4
            movwf         var2
fff35       rrf           var1,F
            rrf           INDF,F
            decfsz        var2,F
            goto          fff35

            incf          FSR,F
            movf          INDF,W
            movwf         tmp
            swapf         INDF,W
            movwf         var1
            movlw         b'00001111'
            andwf         var1,F
            incf          var1,F
            incf          var1,F
            movlw         .8
            subwf         var1,W
            btfsc         STATUS,Z
            goto          fig4 
            movlw         b'00001111'
            andwf         tmp,F    
            swapf         tmp,W
            movwf         INDF
            movlw         .4
            movwf         var2
fff36       rrf           var1,F
            rrf           INDF,F
            decfsz        var2,F
            goto          fff36
            bcf           flag,1
            movlw         .1
            movwf         povorot
            bcf           PCLATH,3
            return
fig4        bsf           flag,1
            bcf           PCLATH,3
            return

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

figura4     movf          INDF,W
            movwf         tmpfig1
            incf          FSR,F
            movf          INDF,W
            movwf         tmpfig2
            incf          FSR,F
            movf          INDF,W
            movwf         tmpfig3
            incf          FSR,F
            movf          INDF,W
            movwf         tmpfig4
            movlw         tmpfig1
            movwf         FSR
            btfsc         flag,2
            goto          fig55

            movf          INDF,W
            movwf         tmp
            swapf         INDF,W
            movwf         var1
            movlw         b'00001111'
            andwf         var1,F
            movlw         b'00001111'
            andwf         tmp,F
            incf          tmp,F           
            swapf         tmp,W
            movwf         INDF
            movlw         .4
            movwf         var2
fff37       rrf           var1,F
            rrf           INDF,F
            decfsz        var2,F
            goto          fff37

            incf          FSR,F
            movf          INDF,W
            movwf         tmp
            swapf         INDF,W
            movwf         var1
            movlw         b'00001111'
            andwf         var1,F
            decf          var1,F
            movlw         b'00001111'
            andwf         tmp,F
            swapf         tmp,W
            movwf         INDF
            movlw         .4
            movwf         var2
fff38       rrf           var1,F
            rrf           INDF,F
            decfsz        var2,F
            goto          fff38

            incf          FSR,F
            movf          INDF,W
            movwf         tmp
            swapf         INDF,W
            movwf         var1
            movlw         b'00001111'
            andwf         var1,F
            movlw         b'00001111'
            andwf         tmp,F
            decf          tmp,F
            swapf         tmp,W
            movwf         INDF
            movlw         .4
            movwf         var2
fff39       rrf           var1,F
            rrf           INDF,F
            decfsz        var2,F
            goto          fff39

            incf          FSR,F
            movf          INDF,W
            movwf         tmp
            swapf         INDF,W
            movwf         var1
            movlw         b'00001111'
            andwf         var1,F
            decf          var1,F
            movlw         b'00001111'
            andwf         tmp,F
            decf          tmp,F
            decf          tmp,F
            movlw         .255
            subwf         tmp,W
            btfsc         STATUS,Z
            goto          fig5 
            swapf         tmp,W
            movwf         INDF
            movlw         .4
            movwf         var2
fff40       rrf           var1,F
            rrf           INDF,F
            decfsz        var2,F
            goto          fff40
            bcf           flag,1
            bsf           flag,2
            bcf           PCLATH,3
            return
         

fig55       movf          INDF,W
            movwf         tmp
            swapf         INDF,W
            movwf         var1
            movlw         b'00001111'
            andwf         var1,F
            movlw         b'00001111'
            andwf         tmp,F 
            decf          tmp,F          
            swapf         tmp,W
            movwf         INDF
            movlw         .4
            movwf         var2
fff41       rrf           var1,F
            rrf           INDF,F
            decfsz        var2,F
            goto          fff41

            incf          FSR,F
            movf          INDF,W
            movwf         tmp
            swapf         INDF,W
            movwf         var1
            movlw         b'00001111'
            andwf         var1,F
            incf          var1,F
            movlw         b'00001111'
            andwf         tmp,F
            swapf         tmp,W
            movwf         INDF
            movlw         .4
            movwf         var2
fff42       rrf           var1,F
            rrf           INDF,F
            decfsz        var2,F
            goto          fff42

            incf          FSR,F
            movf          INDF,W
            movwf         tmp
            swapf         INDF,W
            movwf         var1
            movlw         b'00001111'
            andwf         var1,F
            movlw         b'00001111'
            andwf         tmp,F
            incf          tmp,F
            swapf         tmp,W
            movwf         INDF
            movlw         .4
            movwf         var2
fff43       rrf           var1,F
            rrf           INDF,F
            decfsz        var2,F
            goto          fff43

            incf          FSR,F
            movf          INDF,W
            movwf         tmp
            swapf         INDF,W
            movwf         var1
            movlw         b'00001111'
            andwf         var1,F
            incf          var1,F
            movlw         .8
            subwf         var1,W
            btfsc         STATUS,Z
            goto          fig5
            movlw         b'00001111'
            andwf         tmp,F
            incf          tmp,F
            incf          tmp,F
            swapf         tmp,W
            movwf         INDF
            movlw         .4
            movwf         var2
fff44       rrf           var1,F
            rrf           INDF,F
            decfsz        var2,F
            goto          fff44
            bcf           flag,1
            bcf           flag,2
            bcf           PCLATH,3
            return
fig5        bsf           flag,1
            bcf           PCLATH,3
            return

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

figura6     movf          INDF,W
            movwf         tmpfig1
            incf          FSR,F
            movf          INDF,W
            movwf         tmpfig2
            incf          FSR,F
            movf          INDF,W
            movwf         tmpfig3
            incf          FSR,F
            movf          INDF,W
            movwf         tmpfig4
            movlw         tmpfig1
            movwf         FSR
            movlw         .1
            subwf         povorot,W
            btfsc         STATUS,Z
            goto          fig61
            movlw         .2
            subwf         povorot,W
            btfsc         STATUS,Z
            goto          fig62
            movlw         .3
            subwf         povorot,W
            btfsc         STATUS,Z
            goto          fig63
            goto          fig64

fig61       movf          INDF,W
            movwf         tmp
            swapf         INDF,W
            movwf         var1
            movlw         b'00001111'
            andwf         var1,F
            incf          var1,F
            incf          var1,F
            movlw         b'00001111'
            andwf         tmp,F   
            swapf         tmp,W
            movwf         INDF
            movlw         .4
            movwf         var2
fff45       rrf           var1,F
            rrf           INDF,F
            decfsz        var2,F
            goto          fff45

            incf          FSR,F
            movf          INDF,W
            movwf         tmp
            swapf         INDF,W
            movwf         var1
            movlw         b'00001111'
            andwf         var1,F
            incf          var1,F
            movlw         b'00001111'
            andwf         tmp,F 
            incf          tmp,F      
            swapf         tmp,W
            movwf         INDF
            movlw         .4
            movwf         var2
fff46       rrf           var1,F
            rrf           INDF,F
            decfsz        var2,F
            goto          fff46

            incf          FSR,F
            incf          FSR,F
            movf          INDF,W
            movwf         tmp
            swapf         INDF,W
            movwf         var1
            movlw         b'00001111'
            andwf         var1,F
            decf          var1,F
            movlw         b'00001111'
            andwf         tmp,F 
            decf          tmp,F
            movlw         .255
            subwf         tmp,W
            btfsc         STATUS,Z
            goto          fig6          
            swapf         tmp,W
            movwf         INDF
            movlw         .4
            movwf         var2
fff47       rrf           var1,F
            rrf           INDF,F
            decfsz        var2,F
            goto          fff47
            bcf           flag,1
            incf          povorot,F
            bcf           PCLATH,3
            return

fig62       movf          INDF,W
            movwf         tmp
            swapf         INDF,W
            movwf         var1
            movlw         b'00001111'
            andwf         var1,F
            movlw         b'00001111'
            andwf         tmp,F
            decf          tmp,F 
            decf          tmp,F      
            swapf         tmp,W
            movwf         INDF
            movlw         .4
            movwf         var2
fff48       rrf           var1,F
            rrf           INDF,F
            decfsz        var2,F
            goto          fff48

            incf          FSR,F
            movf          INDF,W
            movwf         tmp
            swapf         INDF,W
            movwf         var1
            movlw         b'00001111'
            andwf         var1,F
            incf          var1,F          
            movlw         b'00001111'
            andwf         tmp,F 
            decf          tmp,F     
            swapf         tmp,W
            movwf         INDF
            movlw         .4
            movwf         var2
fff49       rrf           var1,F
            rrf           INDF,F
            decfsz        var2,F
            goto          fff49

            incf          FSR,F
            incf          FSR,F
            movf          INDF,W
            movwf         tmp
            swapf         INDF,W
            movwf         var1
            movlw         b'00001111'
            andwf         var1,F
            decf          var1,F
            movlw         .255
            subwf         var1,W
            btfsc         STATUS,Z
            goto          fig6
            movlw         b'00001111'
            andwf         tmp,F 
            incf          tmp,F     
            swapf         tmp,W
            movwf         INDF
            movlw         .4
            movwf         var2
fff50       rrf           var1,F
            rrf           INDF,F
            decfsz        var2,F
            goto          fff50
            bcf           flag,1
            incf          povorot,F
            bcf           PCLATH,3
            return

fig63       movf          INDF,W
            movwf         tmp
            swapf         INDF,W
            movwf         var1
            movlw         b'00001111'
            andwf         var1,F
            decf          var1,F  
            decf          var1,F        
            movlw         b'00001111'
            andwf         tmp,F                   
            swapf         tmp,W
            movwf         INDF
            movlw         .4
            movwf         var2
fff51       rrf           var1,F
            rrf           INDF,F
            decfsz        var2,F
            goto          fff51

            incf          FSR,F
            movf          INDF,W
            movwf         tmp
            swapf         INDF,W
            movwf         var1
            movlw         b'00001111'
            andwf         var1,F
            decf          var1,F
            movlw         b'00001111'
            andwf         tmp,F 
            decf          tmp,F           
            swapf         tmp,W
            movwf         INDF
            movlw         .4
            movwf         var2
fff52       rrf           var1,F
            rrf           INDF,F
            decfsz        var2,F
            goto          fff52

            incf          FSR,F
            incf          FSR,F
            movf          INDF,W
            movwf         tmp
            swapf         INDF,W
            movwf         var1
            movlw         b'00001111'
            andwf         var1,F
            incf          var1,F
            movlw         b'00001111'
            andwf         tmp,F 
            incf          tmp,F     
            swapf         tmp,W
            movwf         INDF
            movlw         .4
            movwf         var2
fff53       rrf           var1,F
            rrf           INDF,F
            decfsz        var2,F
            goto          fff53
            bcf           flag,1
            incf          povorot,F
            bcf           PCLATH,3
            return

fig64       movf          INDF,W
            movwf         tmp
            swapf         INDF,W
            movwf         var1
            movlw         b'00001111'
            andwf         var1,F
            movlw         b'00001111'
            andwf         tmp,F
            incf          tmp,F 
            incf          tmp,F     
            swapf         tmp,W
            movwf         INDF
            movlw         .4
            movwf         var2
fff54       rrf           var1,F
            rrf           INDF,F
            decfsz        var2,F
            goto          fff54

            incf          FSR,F
            movf          INDF,W
            movwf         tmp
            swapf         INDF,W
            movwf         var1
            movlw         b'00001111'
            andwf         var1,F
            decf          var1,F            
            movlw         b'00001111'
            andwf         tmp,F 
            incf          tmp,F     
            swapf         tmp,W
            movwf         INDF
            movlw         .4
            movwf         var2
fff55       rrf           var1,F
            rrf           INDF,F
            decfsz        var2,F
            goto          fff55

            incf          FSR,F
            incf          FSR,F
            movf          INDF,W
            movwf         tmp
            swapf         INDF,W
            movwf         var1
            movlw         b'00001111'
            andwf         var1,F
            incf          var1,F
            movlw         .8
            subwf         var1,W
            btfsc         STATUS,Z
            goto          fig6 
            movlw         b'00001111'
            andwf         tmp,F 
            decf          tmp,F   
            swapf         tmp,W
            movwf         INDF
            movlw         .4
            movwf         var2
fff56       rrf           var1,F
            rrf           INDF,F
            decfsz        var2,F
            goto          fff56
            bcf           flag,1
            movlw         .1
            movwf         povorot
            bcf           PCLATH,3
            return
fig6        bsf           flag,1
            bcf           PCLATH,3
            return


;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;



            END

;flag,0 -     TMR1 4  ,  
;          .
;flag,1 -           .
;flag,2 -     ( : figura0,figura1,figura4)
;flag,3 -      
;flag,4 -    STATUS,IRP
;flag,5 -     
;flag,6 -   STATUS,C
;flag,7 -      Start
;flag1,0 -    
;flag1,1 -    
;flag1,2 -    
;flag1,3 -    
;flag1,4 -     
;flag1,5 -     
;flag1,6 -     
;flag1,7 -     
;flag3,0 -   16     
;flag3,1 -      ,    